<template>
  <el-select
    v-model="selected"
    class="archives-select"
    :placeholder="placeholder"
    filterable
    :clearable="clearable"
    :disabled="disabled"
    @change="select"
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :value="item.id"
      :label="item.name"
    >
    </el-option>
  </el-select>
</template>

<script>
import { commonArchivesQuery } from "../../modules/client/api";

export default {
  name: "archives-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "请选择学期" },
    value: { type: [Number, String], default: "" },
    clearable: { type: Boolean, default: true },
    semesterId: { type: String, default: "" }
  },
  data() {
    return {
      optionList: [],
      selected: ""
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      }
    },
    semesterId(val, oldval) {
      if (val !== oldval) {
        this.search("");
        this.$emit("input", "");
        this.$emit("change", {});
      }
    }
  },
  created() {
    this.search();
  },
  methods: {
    async search() {
      this.optionList = [];

      let data = {};
      if (this.semesterId) data.semesterId = this.semesterId;

      const res = await commonArchivesQuery(data);
      this.optionList = res;
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit(
        "change",
        this.optionList.find(item => item.id === this.selected)
      );
    }
  }
};
</script>
